diff -urN golded+cvs20090710-src/Config.def golded-nsf-v003/Config.def
--- golded+cvs20090710-src/Config.def	2009-04-04 13:49:06.000000000 +0400
+++ golded-nsf-v003/Config.def	2009-07-10 09:58:18.000000000 +0400
@@ -81,6 +81,8 @@
 #CPPFLAGS+=-DGCFG_NO_MYSPELL
 # Uncomment to disable regex search feature
 #CPPFLAGS+=-DGCFG_NO_REGEX
+# Uncomment to disable PCRE regex feature
+#CPPFLAGS+=-DGCFG_NO_PCRE
 # Comment to disable AreaRecycleBin keyword and feature
 CPPFLAGS+=-D__INCLUDE_NEW_KEYWORDS__
 # Uncomment to disable CPUID feature (compilation error in goldlib/gall/gutlvers.cpp)
@@ -124,5 +126,6 @@
   -DGCFG_NOXMAIL     \
   -DGCFG_NOSYNCHRONET \
   -DGCFG_NO_MSSPELL   \
-  -DGCFG_NO_MYSPELL
+  -DGCFG_NO_MYSPELL   \
+  -DGCFG_NO_PCRE
 endif
diff -urN golded+cvs20090710-src/GNUmakef.prg golded-nsf-v003/GNUmakef.prg
--- golded+cvs20090710-src/GNUmakef.prg	2001-02-24 21:37:27.000000000 +0300
+++ golded-nsf-v003/GNUmakef.prg	2009-07-10 09:58:18.000000000 +0400
@@ -14,7 +14,7 @@
 
 $(TOP)/$(BIN)/$(SHORTTARGET)$(PLATFORM)$(EXEEXT): $(OBJS) $(FGLIBS) $(ADDS)
 	@echo -n Linking $(TARGET)...
-	@$(CXX) $(LNKFLAGS) -o $@ $(FOBJPATH)/*$(OBJEXT) $(ADDS) $(LIBS) -L$(FLIBPATH)
+	@$(CXX) $(CFLAGS) $(LNKFLAGS) -o $@ $(FOBJPATH)/*$(OBJEXT) $(ADDS) $(LIBS) -L$(FLIBPATH)
 	@echo done
 
 $(FGLIBS): $(GLIBS)
diff -urN golded+cvs20090710-src/golded3/gccfgg0.cpp golded-nsf-v003/golded3/gccfgg0.cpp
--- golded+cvs20090710-src/golded3/gccfgg0.cpp	2007-06-21 23:03:17.000000000 +0400
+++ golded-nsf-v003/golded3/gccfgg0.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -32,6 +32,7 @@
 //  ------------------------------------------------------------------
 
 bool cfgingroup = false;
+bool cfgingroupurl = false;
 char* val;
 
 
@@ -283,6 +284,7 @@
     case CRC_DISPATTACHSIZE   :  CfgDispattachsize   ();  break;
     case CRC_DISPHDRDATESET   :  CfgDisphdrdateset   ();  break;
     case CRC_DISPHDRLOCATION  :  CfgDisphdrlocation  ();  break;
+    case CRC_DISPHDRFGHIURL   :  CfgDisphdrfghiurl   ();  break;
     case CRC_DISPHDRNAMESET   :  CfgDisphdrnameset   ();  break;
     case CRC_DISPHDRNODESET   :  CfgDisphdrnodeset   ();  break;
     case CRC_DISPLISTCURSOR   :  CfgDisplistcursor   ();  break;
@@ -326,6 +328,7 @@
     case CRC_EDITSPELLCHECK   :  CfgEditspellcheck   ();  break;
     case CRC_EDITUNDELETE     :  CfgEditundelete     ();  break;
     case CRC_ENDGROUP         :  CfgEndgroup         ();  break;
+    case CRC_ENDGROUPURL      :  CfgEndgroupurl      ();  break;
     case CRC_ENCODEEMAILHEADERS: CfgEncodeemailheaders(); break;
     case CRC_EVENT            :  CfgEvent            ();  break;
     case CRC_EXCLUDENODES     :  CfgExcludenodes     ();  break;
@@ -345,6 +348,8 @@
     case CRC_FIDOUSERLIST     :  CfgFidouserlist     ();  break;
     case CRC_FIDOUSERNO       :  CfgFidouserno       ();  break;
     case CRC_FILEALIAS        :  CfgFilealias        ();  break;
+    case CRC_FGHIGETHANDLER   :  CfgFghigethandler   ();  break;
+    case CRC_FGHIREVERSESEARCH:  CfgFghireversesearch();  break;
     case CRC_FORCETEMPLATE    :  CfgForcetemplate    ();  break;
     case CRC_FRQEXT           :  CfgFrqext           ();  break;
     case CRC_FRQNODEMAP       :  CfgFrqnodemap       ();  break;
@@ -362,6 +367,7 @@
     case CRC_GOLDBASEUSERNO   :  CfgGoldbaseuserno   ();  break;
     case CRC_GOLDPATH         :  CfgGoldpath         ();  break;
     case CRC_GROUP            :  CfgGroup            ();  break;
+    case CRC_GROUPURL         :  CfgGroupurl         ();  break;
     default                   :  found = false;
   }
   goto End;
@@ -437,6 +443,7 @@
     case CRC_MSGLISTDATE      :  CfgMsglistdate      ();  break;
     case CRC_MSGLISTFAST      :  CfgMsglistfast      ();  break;
     case CRC_MSGLISTFIRST     :  CfgMsglistfirst     ();  break;
+    case CRC_MSGLISTFIRSTFGHI :  CfgMsglistfirstfghi ();  break;
     case CRC_MSGLISTHEADER    :  CfgMsglistheader    ();  break;
     case CRC_MSGLISTWIDESUBJ  :  CfgMsglistwidesubj  ();  break;
     default                   :  found = false;
@@ -535,6 +542,7 @@
     case CRC_SCREENPALETTE    :  CfgScreenpalette    ();  break;
     case CRC_SCREENSIZE       :  CfgScreensize       ();  break;
     case CRC_SEARCHFOR        :  CfgSearchfor        ();  break;
+    case CRC_SEARCHURLFOR     :  CfgSearchURLfor     ();  break;
     case CRC_SEMAPHORE        :  CfgSemaphore        ();  break;
     case CRC_SEQDIR           :  CfgSeqDir           ();  break;
     case CRC_SEQMSGID         :  CfgSeqMsgId         ();  break;
@@ -588,6 +596,8 @@
 SwitchU:
   switch(crc) {
     case CRC_UNPACKER         :  CfgUnpacker         ();  break;
+    case CRC_URLBRACKETS      :  CfgUrlbrackets      ();  break;
+    case CRC_URLENGINE        :  CfgUrlengine        ();  break;
     case CRC_URLHANDLER       :  CfgUrlhandler       ();  break;
     case CRC_URLSCHEME        :  CfgUrlscheme        ();  break;
     case CRC_USEAREA          :  CfgUsearea          ();  break;
diff -urN golded+cvs20090710-src/golded3/gccfgg2.cpp golded-nsf-v003/golded3/gccfgg2.cpp
--- golded+cvs20090710-src/golded3/gccfgg2.cpp	2006-01-13 17:26:30.000000000 +0300
+++ golded-nsf-v003/golded3/gccfgg2.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -487,18 +487,24 @@
 
 void CfgDisphdrlocation()
 {
-  char* key;
-  getkeyval(&key, &val);
+  if (strieql("CENTER", val))
+    CFG->disphdrlocation = CFG->disphdrlocation + (TCENTER << 16);
+  else if (strieql("YES", val))
+    CFG->disphdrlocation = CFG->disphdrlocation + (TRIGHT << 16);
+  else
+    CFG->disphdrlocation = 0;
+}
 
-  CFG->disphdrlocation = GetYesno(key);
+//  ------------------------------------------------------------------
 
-  if (CFG->disphdrlocation != NO)
-  {
-    if (strieql("CENTER", val))
-      CFG->disphdrlocation = CFG->disphdrlocation + (TCENTER << 16);
-    else
-      CFG->disphdrlocation = CFG->disphdrlocation + (TRIGHT << 16);
-  }
+void CfgDisphdrfghiurl()
+{
+  if (strieql("SHORT", val))
+    CFG->disphdrfghiurl = TSHORT;
+  else if (strieql("YES", val))
+    CFG->disphdrfghiurl = YES;
+  else
+    CFG->disphdrfghiurl = 0;
 }
 
 //  ------------------------------------------------------------------
diff -urN golded+cvs20090710-src/golded3/gccfgg3.cpp golded-nsf-v003/golded3/gccfgg3.cpp
--- golded+cvs20090710-src/golded3/gccfgg3.cpp	2006-03-11 20:04:06.000000000 +0300
+++ golded-nsf-v003/golded3/gccfgg3.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -352,6 +352,13 @@
 
 //  ------------------------------------------------------------------
 
+void CfgEndgroupurl() {
+
+  cfgingroupurl = false;
+}
+
+//  ------------------------------------------------------------------
+
 void CfgEvent(char* v)  { val = v; CfgEvent(); }
 void CfgEvent() {
 
diff -urN golded+cvs20090710-src/golded3/gccfgg4.cpp golded-nsf-v003/golded3/gccfgg4.cpp
--- golded+cvs20090710-src/golded3/gccfgg4.cpp	2007-01-08 12:48:18.000000000 +0300
+++ golded-nsf-v003/golded3/gccfgg4.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -234,6 +234,21 @@
 
 //  ------------------------------------------------------------------
 
+void CfgFghireversesearch()
+{
+  bool flag = make_bool(GetYesno(val));
+  CFG->fghireversesearch = flag;
+}
+
+//  ------------------------------------------------------------------
+
+void CfgFghigethandler()
+{
+	strxcpy(CFG->fghigethandler, val, sizeof(CFG->fghigethandler));
+}
+
+//  ------------------------------------------------------------------
+
 void CfgForcetemplate() {
 
   bool flag = make_bool(GetYesno(val));
@@ -371,3 +386,13 @@
 }
 
 //  ------------------------------------------------------------------
+
+void CfgGroupurl() {
+
+  char* _key;
+  getkeyval(&_key, &val);
+  CFG->grpurl.AddGrp(_key);
+  cfgingroupurl = true;
+}
+
+//  ------------------------------------------------------------------
diff -urN golded+cvs20090710-src/golded3/gccfgg6.cpp golded-nsf-v003/golded3/gccfgg6.cpp
--- golded+cvs20090710-src/golded3/gccfgg6.cpp	2005-11-01 01:18:25.000000000 +0300
+++ golded-nsf-v003/golded3/gccfgg6.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -46,6 +46,17 @@
 
 //  ------------------------------------------------------------------
 
+void CfgMsglistfirstfghi() {
+
+  bool flag = make_bool(GetYesno(val));
+  if(cfgingroup)
+    CFG->grp.AddItm(GRP_MSGLISTFIRSTFGHI, flag);
+  else
+    CFG->msglistfirstfghi = flag;
+}
+
+//  ------------------------------------------------------------------
+
 void CfgMsglistheader() {
 
   bool flag = make_bool(GetYesno(val));
diff -urN golded+cvs20090710-src/golded3/gccfgg7.cpp golded-nsf-v003/golded3/gccfgg7.cpp
--- golded+cvs20090710-src/golded3/gccfgg7.cpp	2006-12-26 05:05:23.000000000 +0300
+++ golded-nsf-v003/golded3/gccfgg7.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -353,6 +353,18 @@
 
 //  ------------------------------------------------------------------
 
+void CfgSearchURLfor() {
+
+  INam buf;
+  strxcpy(buf, StripQuotes(val), sizeof(buf));
+  if(cfgingroup)
+    CFG->grp.AddItm(GRP_SEARCHURLFOR, buf, strlen(buf)+1);
+  else
+    strcpy(CFG->searchurlfor, buf);
+}
+
+//  ------------------------------------------------------------------
+
 #define CRC_NETSCAN            0xEC12
 #define CRC_ECHOSCAN           0x6E6D
 #define CRC_EXPORTLIST         0x1B14
diff -urN golded+cvs20090710-src/golded3/gccfgg8.cpp golded-nsf-v003/golded3/gccfgg8.cpp
--- golded+cvs20090710-src/golded3/gccfgg8.cpp	2007-06-21 23:03:17.000000000 +0400
+++ golded-nsf-v003/golded3/gccfgg8.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -338,6 +338,13 @@
 
 //  ------------------------------------------------------------------
 
+void CfgUrlengine()
+{
+  if(cfgingroupurl)
+    CFG->grpurl.AddItm(GRPURL_ENGINE, val, strlen(val)+1);
+}
+
+//  ------------------------------------------------------------------
 void CfgUrlhandler()
 {
   // Get util number
@@ -359,17 +366,29 @@
   url.handler.options = CFG->externoptions;
   CFG->externoptions = _optbak;
 
-  CFG->urlhandler.push_back(url);
+  if(cfgingroupurl)
+    CFG->grpurl.AddItm(GRPURL_HANDLER, _val, strlen(_val)+1);
+  else
+	CFG->urlhandler.push_back(url);
 }
 
 //  ------------------------------------------------------------------
 
 void CfgUrlscheme()
 {
+  if(cfgingroupurl)
+    CFG->grpurl.AddItm(GRPURL_SCHEME, val, strlen(val)+1);
 }
 
 //  ------------------------------------------------------------------
 
+void CfgUrlbrackets()
+{
+  bool flag = make_bool(GetYesno(val));
+  CFG->urlbrackets = flag;
+}
+//  ------------------------------------------------------------------
+
 void CfgUsearea() {
 
   bool flag = make_bool(GetYesno(val));
diff -urN golded+cvs20090710-src/golded3/gccfgg.cpp golded-nsf-v003/golded3/gccfgg.cpp
--- golded+cvs20090710-src/golded3/gccfgg.cpp	2007-06-21 23:03:17.000000000 +0400
+++ golded-nsf-v003/golded3/gccfgg.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -685,6 +685,7 @@
   strcpy(quotestring, " FL> ");
   strcpy(quotestops, "<\"\'-");
   *searchfor = 0;
+  *searchurlfor = 0;
   strcpy(stylecodepunct, " !?\"$%&()+,.:;<=>@[\\]^`{|}~\n\r\t");
   *stylecodestops = 0;
   gsprintf(PRINTF_DECLARE_BUFFER(tasktitle), "%s%s%s%s", __gver_prename__,
@@ -726,6 +727,7 @@
   dispareano = true;
   dispattachsize = ATTACH_KBYTES;
   disphdrlocation = NO;
+  disphdrfghiurl = NO;
   displistcursor = NO;
   dispmargin = 0;
   dispmsgsize = DISPMSGSIZE_BYTES;
@@ -737,6 +739,8 @@
   ezycomuserno = 0;
   fidomsgtype = "OPUS";
   fidouserno = 0;
+  fghireversesearch = true;
+  fghigethandler[0] = '\0';
   forcetemplate = false;
   frqoptions = FREQ_FROMTOP;
   peekurloptions = PEEK_FROMTOP;
@@ -761,6 +765,7 @@
   msglistdate = MSGLISTDATE_WRITTEN;
   msglistfast = true;
   msglistfirst = false;
+  msglistfirstfghi = false;
   msglistheader = false;
   msglistwidesubj = false;
   originno = 0;
@@ -806,6 +811,7 @@
   templatematch = false;
   timeout = 0;
   twitmode = TWIT_BLANK;
+  urlbrackets = true;
   usearea = true;
   usecharset = true;
   usefwd = NO;
diff -urN golded+cvs20090710-src/golded3/gccfgg.h golded-nsf-v003/golded3/gccfgg.h
--- golded+cvs20090710-src/golded3/gccfgg.h	2007-06-21 23:03:17.000000000 +0400
+++ golded-nsf-v003/golded3/gccfgg.h	2009-07-10 09:58:18.000000000 +0400
@@ -127,6 +127,7 @@
 const word CRC_DISPAUTONEXT     = 0x52D9;
 const word CRC_DISPHDRDATESET   = 0x65A5;
 const word CRC_DISPHDRLOCATION  = 0x8EF6;
+const word CRC_DISPHDRFGHIURL   = 0x020E;
 const word CRC_DISPHDRNAMESET   = 0xFEF9;
 const word CRC_DISPHDRNODESET   = 0xC232;
 const word CRC_DISPLISTCURSOR   = 0x8B82;
@@ -173,6 +174,7 @@
 const word CRC_EMPTYTEARLINE    = 0x8D0A;
 const word CRC_ENCODEEMAILHEADERS=0xA843;
 const word CRC_ENDGROUP         = 0x4F27;
+const word CRC_ENDGROUPURL      = 0xF6F1;
 const word CRC_EVENT            = 0x0471;
 const word CRC_EXCLUDENODES     = 0x0BFF;
 const word CRC_EXTERNOPTIONS    = 0xECF5;
@@ -189,6 +191,8 @@
 const word CRC_FIDOUSERNO       = 0x903A;
 const word CRC_FILEALIAS        = 0xEC23;
 const word CRC_FILELISTPAGEBAR  = 0x58AA;
+const word CRC_FGHIGETHANDLER   = 0xFD27;
+const word CRC_FGHIREVERSESEARCH= 0xC3BB;
 const word CRC_FORCETEMPLATE    = 0xC8FB;
 const word CRC_FORMFEEDSEPARATOR= 0xDBD6;
 const word CRC_FREEAREA         = 0x93CF;
@@ -206,6 +210,7 @@
 const word CRC_GOLDPATH         = 0x3411;
 const word CRC_GOLDXLAT         = 0x7909;
 const word CRC_GROUP            = 0x1C9B;
+const word CRC_GROUPURL         = 0xAA0F;
 const word CRC_HIGHLIGHTUNREAD  = 0x45DA;
 const word CRC_HIGHLIGHTURLS    = 0xC201;
 const word CRC_HUDSONPATH       = 0x52A7;
@@ -263,6 +268,7 @@
 const word CRC_MSGLISTDATE      = 0xBFF5;
 const word CRC_MSGLISTFAST      = 0xDE86;
 const word CRC_MSGLISTFIRST     = 0x326F;
+const word CRC_MSGLISTFIRSTFGHI = 0xA1DB;
 const word CRC_MSGLISTHEADER    = 0x8B8E;
 const word CRC_MSGLISTPAGEBAR   = 0x8041;
 const word CRC_MSGLISTVIEWSUBJ  = 0xED92;
@@ -337,6 +343,7 @@
 const word CRC_SCREENUSEANSI    = 0x7A70;
 const word CRC_SCREENUSEBIOS    = 0x43DE;
 const word CRC_SEARCHFOR        = 0x9FA6;
+const word CRC_SEARCHURLFOR     = 0xA0EA;
 const word CRC_SEMAPHORE        = 0x02FB;
 const word CRC_SERIALNO         = 0x6EDE;
 const word CRC_SEQDIR           = 0x6426;
@@ -386,8 +393,10 @@
 const word CRC_TWITSUBJ         = 0x08C0;
 const word CRC_TWITTO           = 0x9DFE;
 const word CRC_UNPACKER         = 0x5691;
+const word CRC_URLENGINE        = 0x2521;
 const word CRC_URLHANDLER       = 0x688E;
 const word CRC_URLSCHEME        = 0x89FC;
+const word CRC_URLBRACKETS      = 0xC19E;
 const word CRC_USEAREA          = 0x2FD4;
 const word CRC_USECHARSET       = 0xE1B9;
 const word CRC_USEFLAGS         = 0xE2B6;
diff -urN golded+cvs20090710-src/golded3/gckeys.cpp golded-nsf-v003/golded3/gckeys.cpp
--- golded+cvs20090710-src/golded3/gckeys.cpp	2006-06-16 09:38:23.000000000 +0400
+++ golded-nsf-v003/golded3/gckeys.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -446,6 +446,7 @@
   { CRC_HEADERTOGGLEHUBHOST    , KK_HeaderToggleHubhost  , KT_H }, // 0x2505
   { CRC_K_CPGUP                , Key_C_PgUp              ,    0 }, // 0x2603
   { CRC_READGOTOPREVUNREAD     , KK_ReadGotoPrevUnread   , KT_R }, // 0x27EA
+  { CRC_READFINDURLS           , KK_ReadFindURLs         , KT_R }, // 0x29DA
   { CRC_READTOGGLEREALMSGNO    , KK_ReadToggleRealMsgno  , KT_R }, // 0x2A3B
   { CRC_ADDRESSBOOKPACK        , KK_AddressbookPack      , KT_B }, // 0x2C5C
   { CRC_HEADERTOGGLERETRECREQ  , KK_HeaderToggleRetrecreq, KT_H }, // 0x2CF1
@@ -743,6 +744,7 @@
   { CRC_READTOGGLEBOOKMARK     , KK_ReadToggleBookMark   , KT_R }, // 0xA7E2
   { CRC_EDITSOUNDKILL          , KK_EditSoundkill        , KT_E }, // 0xA9A7
   { CRC_AREAQUITNOW            , KK_AreaQuitNow          , KT_A }, // 0xAAC4
+  { CRC_READGOTOFIRSTURL       , KK_ReadGotoFirstURL     , KT_R }, // 0xAB1D
   { CRC_READNEWAREA            , KK_ReadNewArea          , KT_R }, // 0xAB5E
   { CRC_READQUITNOW            , KK_ReadQuitNow          , KT_R }, // 0xAC15
   { CRC_HEADERTOGGLEUPDREQ     , KK_HeaderToggleUpdreq   , KT_H }, // 0xAC35
diff -urN golded+cvs20090710-src/golded3/gckeys.h golded-nsf-v003/golded3/gckeys.h
--- golded+cvs20090710-src/golded3/gckeys.h	2006-06-16 09:38:23.000000000 +0400
+++ golded-nsf-v003/golded3/gckeys.h	2009-07-10 09:58:18.000000000 +0400
@@ -236,6 +236,7 @@
 const word CRC_READFORCEDELETEMSG   = 0xD57A;
 const word CRC_READGOTOBOOKMARK     = 0x4383;
 const word CRC_READGOTOFIRSTMSG     = 0x392F;
+const word CRC_READGOTOFIRSTURL     = 0xAB1D;
 const word CRC_READGOTOLASTMSG      = 0x9E72;
 const word CRC_READGOTOMSGNO        = 0x73F7;
 const word CRC_READGOTONEXTAREA     = 0x5B23;
@@ -271,6 +272,7 @@
 const word CRC_READNEWAREA          = 0xAB5E;
 const word CRC_READNEWMSG           = 0x30CA;
 const word CRC_READPEEKURLS         = 0x07BA;
+const word CRC_READFINDURLS         = 0x29DA;
 const word CRC_READQUITNOW          = 0xAC15;
 const word CRC_READQUOTEBUF         = 0x49EE;
 const word CRC_READQUOTEMSG         = 0xBE00;
diff -urN golded+cvs20090710-src/golded3/gclang.cpp golded-nsf-v003/golded3/gclang.cpp
--- golded+cvs20090710-src/golded3/gclang.cpp	2007-04-03 23:17:42.000000000 +0400
+++ golded-nsf-v003/golded3/gclang.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -215,6 +215,7 @@
   { CRC_HD_TO                 , NULL  , " To   : " },
   { CRC_HD_SUBJ               , NULL  , " Subj : " },
   { CRC_HD_FILE               , NULL  , " File : " },
+  { CRC_HD_NOMSGID            , NULL  , " Message doesn't contain the msgid " },
   { CRC_MS_EMPTYMSG           , NULL  , "\r" },
   { CRC_MS_AUTOATTACHMSG      , NULL  , "\r" },
   { CRC_MS_AUTOREQUESTMSG     , NULL  , "\r" },
@@ -231,8 +232,9 @@
   { CRC_MS_HIDINGTWIT         , NULL  , "This is a Twit Message - Press <Home> to read."},
   { CRC_HD_VIA                , NULL  , "via" },
   { CRC_WT_CHANGEATTRS        , NULL  , "Change Message Attributes" },
-  { CRC_WT_HEADERTEXT         , NULL  , " Enter Searchstring (Header+Text) " },
-  { CRC_WT_HEADERONLY         , NULL  , " Enter Searchstring (Header Only) " },
+  { CRC_WT_HEADERTEXT         , NULL  , " Enter Search string (Header+Text) " },
+  { CRC_WT_HEADERONLY         , NULL  , " Enter Search string (Header Only) " },
+  { CRC_WT_URLTEXT            , NULL  , " Enter URL for processing " },
   { CRC_WT_NEWAREA            , NULL  , ">>Pick New Area: " },
   { CRC_WT_REPLYAREA          , NULL  , ">>Answer In Area: " },
   { CRC_WT_COPYAREA           , NULL  , ">>Copy To Area: " },
@@ -468,6 +470,7 @@
   { CRC_WT_ADDRESSBOOK        , NULL  , " Addressbook " },
   { CRC_WT_ADVANCEDSEARCH     , NULL  , " Advanced Search " },
   { CRC_IL_NOMOREMATCHES      , NULL  , " No more matches found " },
+  { CRC_IL_NOAREAFOUND        , NULL  , " Area %s not found " },
   { CRC_WT_HEADEREDITHELP_1   , NULL  , " Shift-F10: Nodelist " },
   { CRC_WT_HEADEREDITHELP_2   , NULL  , " F10: Addressbook " },
   { CRC_WT_THREADLISTTITLE    , NULL  , " Message Thread List " },
@@ -517,6 +520,14 @@
   { CRC_MI_MMWRITE            , NULL  , "W Write to disk/printer " },
   { CRC_MI_MMFREQ             , NULL  , "F File request          " },
 
+  { CRC_IL_FGHIERRORGET       , NULL  , " Error occured during retriving message " },
+  { CRC_IL_FGHIERROREMPTY     , NULL  , " Server answered nothing or connection error " },
+  { CRC_IL_FGHINOMESSAGE      , NULL  , " Message not exists in our base " },
+  { CRC_IL_FGHISRVFATALERROR  , NULL  , " Unknown error occured " },
+  { CRC_IL_FGHISRVNOMESSAGE   , NULL  , " Server doesn't have this message " },
+  { CRC_IL_FGHISRVNOACCESS    , NULL  , " You doesn't have access to this message " },
+  { CRC_IL_FGHISRVUNKNOWNERR  , NULL  , " Server return unknown error " },
+
   { CRC_LAST_CRC              , NULL  , NULL }
 };
 
diff -urN golded+cvs20090710-src/golded3/gclang.h golded-nsf-v003/golded3/gclang.h
--- golded+cvs20090710-src/golded3/gclang.h	2007-01-19 20:38:41.000000000 +0300
+++ golded-nsf-v003/golded3/gclang.h	2009-07-10 09:58:18.000000000 +0400
@@ -208,6 +208,7 @@
 const word CRC_HD_TO                = 0x8A51;
 const word CRC_HD_SUBJ              = 0xD621;
 const word CRC_HD_FILE              = 0xF715;
+const word CRC_HD_NOMSGID           = 0x5072;
 const word CRC_MS_EMPTYMSG          = 0xF2BA;
 const word CRC_MS_TEMPLATE          = 0x6B5A;
 const word CRC_MS_AUTOATTACHMSG     = 0xA68A;
@@ -233,6 +234,7 @@
 const word CRC_WT_CHANGEATTRS       = 0x03C1;
 const word CRC_WT_HEADERTEXT        = 0x7C39;
 const word CRC_WT_HEADERONLY        = 0x06D6;
+const word CRC_WT_URLTEXT           = 0xD60E;
 const word CRC_WT_NEWAREA           = 0x44F6;
 const word CRC_WT_REPLYAREA         = 0x2EB5;
 const word CRC_WT_COPYAREA          = 0x7DF5;
@@ -479,6 +481,7 @@
 const word CRC_WT_ADDRESSBOOK       = 0xFEF8;
 const word CRC_WT_ADVANCEDSEARCH    = 0xA8C9;
 const word CRC_IL_NOMOREMATCHES     = 0xD6CC;
+const word CRC_IL_NOAREAFOUND       = 0x83A5;
 const word CRC_WT_HEADEREDITHELP_1  = 0x27A8;
 const word CRC_WT_HEADEREDITHELP_2  = 0x27AB;
 const word CRC_WT_THREADLISTTITLE   = 0x07CF;
@@ -528,6 +531,14 @@
 const word CRC_MI_MMWRITE           = 0xBA20;
 const word CRC_MI_MMFREQ            = 0xF5B5;
 
+const word CRC_IL_FGHIERRORGET      = 0x7036;
+const word CRC_IL_FGHIERROREMPTY    = 0xADD8;
+const word CRC_IL_FGHINOMESSAGE     = 0xF531;
+const word CRC_IL_FGHISRVFATALERROR = 0xF043;
+const word CRC_IL_FGHISRVNOMESSAGE  = 0xB6E0;
+const word CRC_IL_FGHISRVNOACCESS   = 0x9BE4;
+const word CRC_IL_FGHISRVUNKNOWNERR = 0xBA02;
+
 const word CRC_LAST_CRC             = 0xFFFF;
 
 
diff -urN golded+cvs20090710-src/golded3/gcprot.h golded-nsf-v003/golded3/gcprot.h
--- golded+cvs20090710-src/golded3/gcprot.h	2007-06-21 23:03:18.000000000 +0400
+++ golded-nsf-v003/golded3/gcprot.h	2009-07-10 09:58:18.000000000 +0400
@@ -125,6 +125,7 @@
 void CfgDispautonext     ();
 void CfgDisphdrdateset   ();
 void CfgDisphdrlocation  ();
+void CfgDisphdrfghiurl   ();
 void CfgDisphdrnameset   ();
 void CfgDisphdrnodeset   ();
 void CfgDisplistcursor   ();
@@ -170,6 +171,7 @@
 void CfgEmptytearline    ();
 void CfgEncodeemailheaders();
 void CfgEndgroup         ();
+void CfgEndgroupurl      ();
 void CfgEvent            ();
 void CfgExcludenodes     ();
 void CfgExternoptions    ();
@@ -185,6 +187,8 @@
 void CfgFidouserno       ();
 void CfgFilealias        ();
 void CfgFilelistpagebar  ();
+void CfgFghireversesearch();
+void CfgFghigethandler   ();
 void CfgFollowupto       ();
 void CfgForcetemplate    ();
 void CfgFrqext           ();
@@ -198,6 +202,7 @@
 void CfgGoldbaseuserno   ();
 void CfgGoldpath         ();
 void CfgGroup            ();
+void CfgGroupurl         ();
 void CfgHighlightunread  ();
 void CfgHighlighturls    ();
 void CfgHudsonpath       ();
@@ -250,6 +255,7 @@
 void CfgMsglistdate      ();
 void CfgMsglistfast      ();
 void CfgMsglistfirst     ();
+void CfgMsglistfirstfghi ();
 void CfgMsglistheader    ();
 void CfgMsglistpagebar   ();
 void CfgMsglistviewsubj  ();
@@ -320,6 +326,7 @@
 void CfgScreensize       ();
 void CfgScreenusebios    ();
 void CfgSearchfor        ();
+void CfgSearchURLfor     ();
 void CfgSemaphore        ();
 void CfgSeqDir           ();
 void CfgSeqMsgId         ();
@@ -366,8 +373,10 @@
 void CfgTwitsubj         ();
 void CfgTwitto           ();
 void CfgUnpacker         ();
+void CfgUrlengine        ();
 void CfgUrlhandler       ();
 void CfgUrlscheme        ();
+void CfgUrlbrackets      ();
 void CfgUsearea          ();
 void CfgUsecharset       ();
 void CfgUseflags         ();
diff -urN golded+cvs20090710-src/golded3/gecfgg.h golded-nsf-v003/golded3/gecfgg.h
--- golded+cvs20090710-src/golded3/gecfgg.h	2007-06-21 23:03:18.000000000 +0400
+++ golded-nsf-v003/golded3/gecfgg.h	2009-07-10 09:58:18.000000000 +0400
@@ -213,6 +213,7 @@
   Path        golduser;
 
   Grp         grp;
+  Grp         grpurl;
 
   int         cfgeditquotemargin;
 
@@ -291,6 +292,7 @@
   int         dispareano;
   int         dispattachsize;
   int         disphdrlocation;
+  int         disphdrfghiurl;
   PosLen      disphdrdateset;
   PosLen      disphdrnameset;
   PosLen      disphdrnodeset;
@@ -311,6 +313,8 @@
   Path        fidouserlist;
   int         fidouserno;           // lastreaduser;
   std::vector<FileAlias> filealias;
+  char        fghigethandler[255];
+  bool        fghireversesearch;
   bool        forcetemplate;
   gstrarray   frqext;
   std::vector<FrqNodeMap> frqnodemap;
@@ -359,6 +363,7 @@
   int         msglistdate;
   bool        msglistfast;
   bool        msglistfirst;
+  bool        msglistfirstfghi;
   bool        msglistheader;
   bool        msglistwidesubj;
   Path        namesfile;
@@ -411,6 +416,7 @@
   int         screenpalette[17];
   int         screensize;
   INam        searchfor;
+  INam        searchurlfor;
   Semaphore   semaphore;
   Path        seqdir;
   int         seqmsgid;
@@ -453,6 +459,7 @@
   gstrarray   twitsubj;
   std::vector< std::pair<std::string, std::string> > unpacker;
   std::vector<UrlHandler> urlhandler;
+  bool        urlbrackets;
   bool        usearea;
   bool        usecharset;
   int         usefwd;
diff -urN golded+cvs20090710-src/golded3/gectnr.cpp golded-nsf-v003/golded3/gectnr.cpp
--- golded+cvs20090710-src/golded3/gectnr.cpp	2006-01-13 17:26:30.000000000 +0300
+++ golded-nsf-v003/golded3/gectnr.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -72,6 +72,10 @@
     return ptr+5;
   if(strnieql(ptr, "ed2k://", 7))
     return ptr+7;
+  if(strnieql(ptr, "area://", 7))
+    return ptr+7;
+  if(strnieql(ptr, "area:", 5))
+    return ptr+5;
   return NULL;
 }
 
@@ -161,7 +165,9 @@
 
         if(((begin = url_begin(ptr)) != NULL) and
            ((ptr == text) or (not isxalnum(ptr[-1]) and (ptr[-1] != '@')))) {
-          const char *end = begin+strcspn(begin, " \t\"\'<>()[]");
+          const char *end;
+          if (CFG->urlbrackets) end = begin+strcspn(begin, " \t\"\'");
+          else end = begin+strcspn(begin, " \t\"\'<>()[]");
 
           if(ispunct(end[-1]) and (end[-1] != '/'))
             --end;
diff -urN golded+cvs20090710-src/golded3/gefind.cpp golded-nsf-v003/golded3/gefind.cpp
--- golded+cvs20090710-src/golded3/gefind.cpp	2006-05-14 15:45:05.000000000 +0400
+++ golded-nsf-v003/golded3/gefind.cpp	2009-07-10 09:58:18.000000000 +0400
@@ -56,6 +56,14 @@
   }
 }
 
+void FindURL(GMsg* msg, int& topline, int& keyok) {
+
+      if(edit_string(CFG->searchurlfor, sizeof(INam), LNG->URLText, H_FindURLString)) {
+		  GotoURL(msg,CFG->searchurlfor);
+	      keyok = true;
+	  }
+}
+
 
 //  ------------------------------------------------------------------
 
@@ -91,7 +99,7 @@
 
 //  ------------------------------------------------------------------
 
-bool FindString(GMsg* msg, const char* prompt, int what) {
+bool FindString(GMsg* msg, const char* prompt, int what, bool showerror) {
 
   GFTRK("FindString");
 
@@ -186,7 +194,7 @@
   if(breakloop)
   HandleGEvent(EVTT_BREAKLOOP);
 
-  if(not result) {
+  if(not result && showerror) {
     w_info(LNG->NoMoreMatches);
     waitkeyt(5000);
     w_info(NULL);
diff -urN golded+cvs20090710-src/golded3/geglob.h golded-nsf-v003/golded3/geglob.h
--- golded+cvs20090710-src/golded3/geglob.h	2006-05-14 18:33:21.000000000 +0400
+++ golded-nsf-v003/golded3/geglob.h	2009-07-10 09:58:18.000000000 +0400
@@ -52,6 +52,7 @@
 
 // GCCFGG.CPP
 extern bool cfgingroup;
+extern bool cfgingroupurl;
 
 // GCKEYS.CPP
 extern CmdKey DefaultKeyset[];
@@ -94,6 +95,7 @@
 extern int reader_keyok;
 extern int reader_direction;
 extern int reader_rcv_noise;
+extern bool reader_url;
 extern gkey reader_keycode;
 extern GMsgHeaderView *HeaderView;
 extern GMsgBodyView *BodyView;
diff -urN golded+cvs20090710-src/golded3/gehelp.h golded-nsf-v003/golded3/gehelp.h
--- golded+cvs20090710-src/golded3/gehelp.h	2006-05-14 18:33:21.000000000 +0400
+++ golded-nsf-v003/golded3/gehelp.h	2009-07-10 09:58:18.000000000 +0400
@@ -82,6 +82,7 @@
 #define H_ReadExternUtil    3017
 #define H_PeekURL           3018
 #define H_MainMenu          3019
+#define H_FindURLString     3020
 
 
 //  ------------------------------------------------------------------
